Index: issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 18081)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 18301)
@@ -104,5 +104,9 @@
 	/*Prepare solver*/
 	KSPCreate(IssmComm::GetComm(),&ksp);
-	KSPSetOperators(ksp,Kff,Kff,DIFFERENT_NONZERO_PATTERN);
+	#if (_PETSC_MAJOR_==3) && (_PETSC_MINOR_>=5)
+		KSPSetOperators(ksp,Kff,Kff);
+	#else
+		KSPSetOperators(ksp,Kff,Kff,DIFFERENT_NONZERO_PATTERN);
+	#endif
 	KSPSetFromOptions(ksp);
 
Index: issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp
===================================================================
--- issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 18081)
+++ issm/trunk/src/c/toolkits/petsc/objects/PetscVec.cpp	(revision 18301)
@@ -19,6 +19,5 @@
 
 /*PetscVec constructors and destructor*/
-/*FUNCTION PetscVec::PetscVec(){{{*/
-PetscVec::PetscVec(){
+PetscVec::PetscVec(){/*{{{*/
 	this->vector=NULL;
 	#ifdef _HAVE_ADOLC_
@@ -27,6 +26,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::PetscVec(int M,bool fromlocalsize){{{*/
-PetscVec::PetscVec(int M,bool fromlocalsize){
+PetscVec::PetscVec(int M,bool fromlocalsize){/*{{{*/
 
 	this->vector=NewVec(M,IssmComm::GetComm(),fromlocalsize);
@@ -34,6 +32,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::PetscVec(int m,int M){{{*/
-PetscVec::PetscVec(int m,int M){
+PetscVec::PetscVec(int m,int M){/*{{{*/
 
 	VecCreate(IssmComm::GetComm(),&this->vector);
@@ -44,6 +41,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::PetscVec(Vec petsc_vec){{{*/
-PetscVec::PetscVec(Vec petsc_vec){
+PetscVec::PetscVec(Vec petsc_vec){/*{{{*/
 
 	if(petsc_vec==NULL){
@@ -58,6 +54,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::PetscVec(IssmDouble* serial_vec,int M){{{*/
-PetscVec::PetscVec(IssmDouble* serial_vec,int M){
+PetscVec::PetscVec(IssmDouble* serial_vec,int M){/*{{{*/
 
 	int* idxm=NULL;
@@ -73,6 +68,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::~PetscVec(){{{*/
-PetscVec::~PetscVec(){
+PetscVec::~PetscVec(){/*{{{*/
     VecFree(&this->vector);
 }
@@ -80,6 +74,5 @@
 
 /*PetscVec specific routines: */
-/*FUNCTION PetscVec::Echo{{{*/
-void PetscVec::Echo(void){
+void PetscVec::Echo(void){/*{{{*/
 
 	_assert_(this->vector);
@@ -87,6 +80,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Assemble{{{*/
-void PetscVec::Assemble(void){
+void PetscVec::Assemble(void){/*{{{*/
 
 	_assert_(this->vector);
@@ -96,6 +88,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::SetValues{{{*/
-void PetscVec::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){
+void PetscVec::SetValues(int ssize, int* list, IssmDouble* values, InsMode mode){/*{{{*/
 
 	_assert_(this->vector);
@@ -104,6 +95,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::SetValue{{{*/
-void PetscVec::SetValue(int dof, IssmDouble value, InsMode mode){
+void PetscVec::SetValue(int dof, IssmDouble value, InsMode mode){/*{{{*/
 
 	_assert_(this->vector);
@@ -112,6 +102,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::GetValue{{{*/
-void PetscVec::GetValue(IssmDouble* pvalue,int dof){
+void PetscVec::GetValue(IssmDouble* pvalue,int dof){/*{{{*/
 
 	_assert_(this->vector);
@@ -120,6 +109,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::GetSize{{{*/
-void PetscVec::GetSize(int* pM){
+void PetscVec::GetSize(int* pM){/*{{{*/
 
 	_assert_(this->vector);
@@ -128,6 +116,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::GetLocalSize{{{*/
-void PetscVec::GetLocalSize(int* pM){
+void PetscVec::GetLocalSize(int* pM){/*{{{*/
 
 	_assert_(this->vector);
@@ -136,6 +123,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Duplicate{{{*/
-PetscVec* PetscVec::Duplicate(void){
+PetscVec* PetscVec::Duplicate(void){/*{{{*/
 
 	_assert_(this->vector);
@@ -148,6 +134,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Set{{{*/
-void PetscVec::Set(IssmDouble value){
+void PetscVec::Set(IssmDouble value){/*{{{*/
 
 	_assert_(this->vector);
@@ -156,6 +141,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::AXPY{{{*/
-void PetscVec::AXPY(PetscVec* X, IssmDouble a){
+void PetscVec::AXPY(PetscVec* X, IssmDouble a){/*{{{*/
 
 	_assert_(this->vector);
@@ -164,6 +148,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::AYPX{{{*/
-void PetscVec::AYPX(PetscVec* X, IssmDouble a){
+void PetscVec::AYPX(PetscVec* X, IssmDouble a){/*{{{*/
 
 	_assert_(this->vector);
@@ -172,6 +155,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::ToMPISerial{{{*/
-IssmDouble* PetscVec::ToMPISerial(void){
+IssmDouble* PetscVec::ToMPISerial(void){/*{{{*/
 
 	IssmDouble* vec_serial=NULL;
@@ -181,6 +163,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Copy{{{*/
-void PetscVec::Copy(PetscVec* to){
+void PetscVec::Copy(PetscVec* to){/*{{{*/
 
 	if(this->vector) VecCopy(this->vector,to->vector);
@@ -188,6 +169,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Max{{{*/
-IssmDouble PetscVec::Max(void){
+IssmDouble PetscVec::Max(void){/*{{{*/
 
 	_assert_(this->vector);
@@ -199,6 +179,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Norm{{{*/
-IssmDouble PetscVec::Norm(NormMode mode){
+IssmDouble PetscVec::Norm(NormMode mode){/*{{{*/
 
 	IssmDouble norm=0;
@@ -209,6 +188,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Scale{{{*/
-void PetscVec::Scale(IssmDouble scale_factor){
+void PetscVec::Scale(IssmDouble scale_factor){/*{{{*/
 
 	_assert_(this->vector);
@@ -217,6 +195,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::Dot{{{*/
-IssmDouble PetscVec::Dot(PetscVec* input){
+IssmDouble PetscVec::Dot(PetscVec* input){/*{{{*/
 
 	IssmDouble dot;
@@ -227,6 +204,5 @@
 }
 /*}}}*/
-/*FUNCTION PetscVec::PointwiseDivide{{{*/
-void PetscVec::PointwiseDivide(PetscVec* x,PetscVec* y){
+void PetscVec::PointwiseDivide(PetscVec* x,PetscVec* y){/*{{{*/
 
 	_assert_(this->vector);
Index: issm/trunk/src/dox/issm.dox
===================================================================
--- issm/trunk/src/dox/issm.dox	(revision 18081)
+++ issm/trunk/src/dox/issm.dox	(revision 18301)
@@ -87,4 +87,4 @@
 </table>
 
-	<I> Copyright (C) 2013 </I>
+	<I> Copyright (C) 2014 </I>
   */
Index: issm/trunk/src/m/classes/SMBcomponents.m
===================================================================
--- issm/trunk/src/m/classes/SMBcomponents.m	(revision 18301)
+++ issm/trunk/src/m/classes/SMBcomponents.m	(revision 18301)
@@ -0,0 +1,80 @@
+%SMBcomponents Class definition
+%
+%   Usage:
+%      SMBcomponents=SMBcomponents();
+
+classdef SMBcomponents
+	properties (SetAccess=public) 
+		accumulation = NaN;
+		runoff = NaN;
+		evaporation = NaN;
+	end
+	methods
+		function obj = SMBcomponents(varargin) % {{{
+			switch nargin
+				case 0
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+
+			self.accumulation=project3d(md,'vector',self.accumulation,'type','node');
+			self.runoff=project3d(md,'vector',self.runoff,'type','node');
+			self.evaporation=project3d(md,'vector',self.evaporation,'type','node');
+
+		end % }}}
+		function self = initialize(self,md) % {{{
+
+			if isnan(self.accumulation)
+				self.accumulation=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.accumulation specified: values set as zero');
+			end
+			if isnan(self.evaporation)
+				self.evaporation=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.evaporation specified: values set as zero');
+			end
+			if isnan(self.runoff)
+				self.runoff=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.runoff specified: values set as zero');
+			end
+
+		end % }}}
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
+
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.accumulation','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.accumulation','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.runoff','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.runoff','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.evaporation','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.evaporation','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+		end % }}}
+		function disp(obj) % {{{
+			disp(sprintf('   surface forcings parameters (SMB=accumulation-runoff-evaporation) :'));
+			fielddisplay(obj,'accumulation','accumulated snow [m/yr ice eq]');
+			fielddisplay(obj,'runoff','amount of ice melt lost from the ice column [m/yr ice eq]');
+			fielddisplay(obj,'evaporation','amount of ice lost to evaporative processes [m/yr ice eq]');
+		end % }}}
+		function marshall(obj,md,fid) % {{{
+
+			yts=365.0*24.0*3600.0;
+
+			WriteData(fid,'enum',SurfaceforcingsEnum(),'data',SMBcomponentsEnum(),'format','Integer');
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','accumulation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','runoff','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','evaporation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+		end % }}}
+	end
+end
Index: issm/trunk/src/m/classes/SMBcomponents.py
===================================================================
--- issm/trunk/src/m/classes/SMBcomponents.py	(revision 18301)
+++ issm/trunk/src/m/classes/SMBcomponents.py	(revision 18301)
@@ -0,0 +1,80 @@
+from fielddisplay import fielddisplay
+from EnumDefinitions import *
+from checkfield import *
+from project3d import *
+from WriteData import *
+
+class SMBcomponents(object):
+	"""
+	SMBcomponents Class definition
+
+	   Usage:
+	      SMBcomponents=SMBcomponents();
+	"""
+
+	def __init__(self): # {{{
+		self.accumulation = float('NaN')
+		self.runoff = float('NaN')
+		self.evaporation = float('NaN')
+		#}}}
+	def __repr__(self): # {{{
+		string="   surface forcings parameters (SMB=accumulation-runoff-evaporation) :"
+		string="%s\n%s"%(string,fielddisplay(self,'accumulation','accumulated snow [m/yr ice eq]'))
+		string="%s\n%s"%(string,fielddisplay(self,'runoff','amount of ice melt lost from the ice column [m/yr ice eq]'))
+		string="%s\n%s"%(string,fielddisplay(self,'evaporation','mount of ice lost to evaporative processes [m/yr ice eq]'))
+		return string
+		#}}}
+	def extrude(self,md): # {{{
+
+		self.mass_balance=project3d(md,'vector',self.accumulation,'type','node');
+		self.mass_balance=project3d(md,'vector',self.runoff,'type','node');
+		self.mass_balance=project3d(md,'vector',self.evaporation,'type','node');
+		return self
+	#}}}
+	def initialize(self,md): # {{{
+
+		if numpy.all(numpy.isnan(self.accumulation)):
+			self.accumulation=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.accumulation specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.runoff)):
+			self.runoff=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.runoff specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.evaporation)):
+			self.evaporation=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.evaporation specified: values set as zero"
+
+		return self
+	#}}}
+	def checkconsistency(self,md,solution,analyses):    # {{{
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.accumulation','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.accumulation','size',[md.mesh.numberofvertices],'NaN',1)
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.runoff','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.runoff','size',[md.mesh.numberofvertices],'NaN',1)
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.evaporation','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.evaporation','size',[md.mesh.numberofvertices],'NaN',1)
+
+		return md
+	# }}}
+	def marshall(self,md,fid):    # {{{
+
+		yts=365.0*24.0*3600.0
+
+		WriteData(fid,'enum',SurfaceforcingsEnum(),'data',SMBcomponentsEnum(),'format','Integer');
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','accumulation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','runoff','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','evaporation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+	# }}}
Index: issm/trunk/src/m/classes/SMBgradients.m
===================================================================
--- issm/trunk/src/m/classes/SMBgradients.m	(revision 18081)
+++ issm/trunk/src/m/classes/SMBgradients.m	(revision 18301)
@@ -48,6 +48,6 @@
 
 			disp(sprintf('\n   SMB gradients parameters:'));
-			fielddisplay(obj,'href',' reference elevation from which deviation is used to calculate SMB adjustment in smb gradients method');
-			fielddisplay(obj,'smbref',' reference smb from which deviation is calculated in smb gradients method');
+			fielddisplay(obj,'href',' reference elevation from which deviation is used to calculate SMB adjustment in smb gradients method [m]');
+			fielddisplay(obj,'smbref',' reference smb from which deviation is calculated in smb gradients method [mm/yr water equiv]');
 			fielddisplay(obj,'b_pos',' slope of hs - smb regression line for accumulation regime required if smb gradients is activated');
 			fielddisplay(obj,'b_neg',' slope of hs - smb regression line for ablation regime required if smb gradients is activated');
Index: issm/trunk/src/m/classes/SMBmeltcomponents.m
===================================================================
--- issm/trunk/src/m/classes/SMBmeltcomponents.m	(revision 18301)
+++ issm/trunk/src/m/classes/SMBmeltcomponents.m	(revision 18301)
@@ -0,0 +1,94 @@
+%SMBmeltcomponents Class definition
+%
+%   Usage:
+%      SMBmeltcomponents=SMBmeltcomponents();
+
+classdef SMBmeltcomponents
+	properties (SetAccess=public) 
+		accumulation = NaN;
+		evaporation = NaN;
+		melt = NaN;
+		refreeze = NaN;
+	end
+	methods
+		function obj = SMBmeltcomponents(varargin) % {{{
+			switch nargin
+				case 0
+				otherwise
+					error('constructor not supported');
+			end
+		end % }}}
+		function self = extrude(self,md) % {{{
+
+			self.accumulation=project3d(md,'vector',self.accumulation,'type','node');
+			self.evaporation=project3d(md,'vector',self.evaporation,'type','node');
+			self.melt=project3d(md,'vector',self.melt,'type','node');
+			self.refreeze=project3d(md,'vector',self.refreeze,'type','node');
+
+		end % }}}
+		function self = initialize(self,md) % {{{
+
+			if isnan(self.accumulation)
+				self.accumulation=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.accumulation specified: values set as zero');
+			end
+			if isnan(self.evaporation)
+				self.evaporation=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.evaporation specified: values set as zero');
+			end
+			if isnan(self.refreeze)
+				self.refreeze=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.refreeze specified: values set as zero');
+			end
+			if isnan(self.melt)
+				self.melt=zeros(md.mesh.numberofvertices,1);
+				disp('      no surfaceforcings.melt specified: values set as zero');
+			end
+
+		end % }}}
+		function md = checkconsistency(obj,md,solution,analyses) % {{{
+
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.accumulation','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.accumulation','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.evaporation','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.evaporation','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.refreeze','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.refreeze','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+			if ismember(MasstransportAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.melt','forcing',1,'NaN',1);
+			end
+			if ismember(BalancethicknessAnalysisEnum(),analyses),
+				md = checkfield(md,'fieldname','surfaceforcings.melt','size',[md.mesh.numberofvertices 1],'NaN',1);
+			end
+		end % }}}
+		function disp(obj) % {{{
+			disp(sprintf('   surface forcings parameters with melt (SMB=accumulation-evaporation-melt+refreeze) :'));
+			fielddisplay(obj,'accumulation','accumulated snow [m/yr ice eq]');
+			fielddisplay(obj,'evaporation','amount of ice lost to evaporative processes [m/yr ice eq]');
+			fielddisplay(obj,'melt','amount of ice melt in ice column [m/yr ice eq]');
+			fielddisplay(obj,'refreeze','amount of ice melt refrozen in ice column [m/yr ice eq]');
+		end % }}}
+		function marshall(obj,md,fid) % {{{
+
+			yts=365.0*24.0*3600.0;
+
+			WriteData(fid,'enum',SurfaceforcingsEnum(),'data',SMBmeltcomponentsEnum(),'format','Integer');
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','accumulation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','evaporation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','melt','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+			WriteData(fid,'object',obj,'class','surfaceforcings','fieldname','refreeze','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1);
+		end % }}}
+	end
+end
Index: issm/trunk/src/m/classes/SMBmeltcomponents.py
===================================================================
--- issm/trunk/src/m/classes/SMBmeltcomponents.py	(revision 18301)
+++ issm/trunk/src/m/classes/SMBmeltcomponents.py	(revision 18301)
@@ -0,0 +1,93 @@
+from fielddisplay import fielddisplay
+from EnumDefinitions import *
+from checkfield import *
+from project3d import *
+from WriteData import *
+
+class SMBmeltcomponents(object):
+	"""
+	SMBmeltcomponents Class definition
+
+	   Usage:
+	      SMBmeltcomponents=SMBmeltcomponents();
+	"""
+
+	def __init__(self): # {{{
+		self.accumulation = float('NaN')
+		self.runoff = float('NaN')
+		self.evaporation = float('NaN')
+		#}}}
+	def __repr__(self): # {{{
+		string="   surface forcings parameters with melt (SMB=accumulation-evaporation-melt+refreeze) :"
+		string="%s\n%s"%(string,fielddisplay(self,'accumulation','accumulated snow [m/yr ice eq]'))
+		string="%s\n%s"%(string,fielddisplay(self,'evaporation','mount of ice lost to evaporative processes [m/yr ice eq]'))
+		string="%s\n%s"%(string,fielddisplay(self,'melt','amount of ice melt in the ice column [m/yr ice eq]'))
+		string="%s\n%s"%(string,fielddisplay(self,'refreeze','amount of ice melt refrozen in the ice column [m/yr ice eq]'))
+		return string
+		#}}}
+	def extrude(self,md): # {{{
+
+		self.mass_balance=project3d(md,'vector',self.accumulation,'type','node');
+		self.mass_balance=project3d(md,'vector',self.evaporation,'type','node');
+		self.mass_balance=project3d(md,'vector',self.melt,'type','node');
+		self.mass_balance=project3d(md,'vector',self.refreeze,'type','node');
+		return self
+	#}}}
+	def initialize(self,md): # {{{
+
+		if numpy.all(numpy.isnan(self.accumulation)):
+			self.accumulation=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.accumulation specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.evaporation)):
+			self.evaporation=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.evaporation specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.melt)):
+			self.melt=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.melt specified: values set as zero"
+
+		if numpy.all(numpy.isnan(self.refreeze)):
+			self.refreeze=numpy.zeros((md.mesh.numberofvertices,1))
+			print "      no SMB.refreeze specified: values set as zero"
+
+		return self
+	#}}}
+	def checkconsistency(self,md,solution,analyses):    # {{{
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.accumulation','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.accumulation','size',[md.mesh.numberofvertices],'NaN',1)
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.melt','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.melt','size',[md.mesh.numberofvertices],'NaN',1)
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.refreeze','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.refreeze','size',[md.mesh.numberofvertices],'NaN',1)
+
+		if MasstransportAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.evaporation','forcing',1,'NaN',1)
+
+		if BalancethicknessAnalysisEnum() in analyses:
+			md = checkfield(md,'fieldname','surfaceforcings.evaporation','size',[md.mesh.numberofvertices],'NaN',1)
+
+		return md
+	# }}}
+	def marshall(self,md,fid):    # {{{
+
+		yts=365.0*24.0*3600.0
+
+		WriteData(fid,'enum',SurfaceforcingsEnum(),'data',SMBmeltcomponentsEnum(),'format','Integer');
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','accumulation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','evaporation','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','melt','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+		WriteData(fid,'object',self,'class','surfaceforcings','fieldname','refreeze','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+	# }}}
Index: issm/trunk/src/m/classes/balancethickness2.m
===================================================================
--- issm/trunk/src/m/classes/balancethickness2.m	(revision 18081)
+++ issm/trunk/src/m/classes/balancethickness2.m	(revision 18301)
@@ -43,4 +43,9 @@
 			fielddisplay(obj,'spcpotential','potential constraints (NaN means no constraint)');
 			fielddisplay(obj,'apparent_massbalance','Apparent mass balance [m/yr]');
+			fielddisplay(obj,'nux','vx_bar = nux vx_s (in ]0 1])');
+			fielddisplay(obj,'nuy','vy_bar = nuy vy_s (in ]0 1])');
+			fielddisplay(obj,'vx_obs','observed vx');
+			fielddisplay(obj,'vy_obs','observed vy');
+			fielddisplay(obj,'thickness_obs','observed H');
 
 		end % }}}
Index: issm/trunk/src/m/classes/basalforcings.m
===================================================================
--- issm/trunk/src/m/classes/basalforcings.m	(revision 18081)
+++ issm/trunk/src/m/classes/basalforcings.m	(revision 18301)
@@ -6,7 +6,7 @@
 classdef basalforcings
 	properties (SetAccess=public) 
-		melting_rate             = NaN;
-		melting_rate_correction  = NaN;
-		geothermalflux           = NaN;
+		groundedice_melting_rate  = NaN;
+		floatingice_melting_rate  = NaN;
+		geothermalflux            = NaN;
 	end
 	methods
@@ -15,5 +15,4 @@
             fprintf(fid, '%s\n', '<!-- basalforcings -->');
 			 fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="melting_rate" type="',            class(obj.melting_rate),'" default="',              num2str(obj.melting_rate),'">',              '     <section name="basalforcings" />','     <help> basal melting rate (positive if melting) [m/yr] </help>','</parameter>');
-             fprintf(fid,'%s%s%s%s%s\n%s\n%s\n%s\n',    '<parameter key ="melting_rate_correction" type="', class(obj.melting_rate_correction),'" default="',   num2str(obj.melting_rate_correction),'">',   '     <section name="basalforcings" />','     <help> additional melting applied to compensate for dh/dt [m/yr] </help>','</parameter>');
              fprintf(fid,'%s%s%s%s%s\n%s\n%s\n',        '<parameter key ="geothermalflux" type="',          class(obj.geothermalflux),'" default="',            num2str(obj.geothermalflux),'">',            '     <section name="basalforcings" />','     <help> geothermal heat flux [W/m^2] </help>','</parameter>');
              
@@ -29,7 +28,12 @@
 		function self = initialize(self,md) % {{{
 
-			if isnan(self.melting_rate),
-				self.melting_rate=zeros(md.mesh.numberofvertices,1);
-				disp('      no basalforcings.melting_rate specified: values set as zero');
+			if isnan(self.groundedice_melting_rate),
+				self.groundedice_melting_rate=zeros(md.mesh.numberofvertices,1);
+				disp('      no basalforcings.groundedice_melting_rate specified: values set as zero');
+			end
+
+			if isnan(self.floatingice_melting_rate),
+				self.floatingice_melting_rate=zeros(md.mesh.numberofvertices,1);
+				disp('      no basalforcings.floatingice_melting_rate specified: values set as zero');
 			end
 
@@ -41,11 +45,14 @@
 
 			if ismember(MasstransportAnalysisEnum(),analyses) & ~(solution==TransientSolutionEnum() & md.transient.ismasstransport==0),
-				md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'forcing',1);
+				md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'forcing',1);
+				md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'forcing',1);
 			end
 			if ismember(BalancethicknessAnalysisEnum(),analyses),
-				md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'size',[md.mesh.numberofvertices 1]);
+				md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'size',[md.mesh.numberofvertices 1]);
+				md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'size',[md.mesh.numberofvertices 1]);
 			end
 			if ismember(ThermalAnalysisEnum(),analyses) & ~(solution==TransientSolutionEnum() & md.transient.isthermal==0),
-				md = checkfield(md,'fieldname','basalforcings.melting_rate','NaN',1,'forcing',1);
+				md = checkfield(md,'fieldname','basalforcings.groundedice_melting_rate','NaN',1,'forcing',1);
+				md = checkfield(md,'fieldname','basalforcings.floatingice_melting_rate','NaN',1,'forcing',1);
 				md = checkfield(md,'fieldname','basalforcings.geothermalflux','NaN',1,'forcing',1,'>=',0);
 			end
@@ -54,6 +61,6 @@
 			disp(sprintf('   basal forcings parameters:'));
 
-			fielddisplay(obj,'melting_rate','basal melting rate (positive if melting) [m/yr]');
-			fielddisplay(obj,'melting_rate_correction','additional melting applied to compensate for dh/dt [m/yr]');
+			fielddisplay(obj,'groundedice_melting_rate','basal melting rate (positive if melting) [m/yr]');
+			fielddisplay(obj,'floatingice_melting_rate','basal melting rate (positive if melting) [m/yr]');
 			fielddisplay(obj,'geothermalflux','geothermal heat flux [W/m^2]');
 
@@ -63,6 +70,7 @@
 			yts=365.0*24.0*3600.0;
 
-			WriteData(fid,'object',obj,'fieldname','melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
-			WriteData(fid,'object',obj,'fieldname','melting_rate_correction','format','DoubleMat','mattype',1,'scale',1./yts);
+			WriteData(fid,'enum',BasalforcingsEnum(),'data',FloatingMeltRateEnum(),'format','Integer');
+			WriteData(fid,'object',obj,'fieldname','groundedice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
+			WriteData(fid,'object',obj,'fieldname','floatingice_melting_rate','format','DoubleMat','mattype',1,'scale',1./yts,'forcinglength',md.mesh.numberofvertices+1)
 			WriteData(fid,'object',obj,'fieldname','geothermalflux','format','DoubleMat','mattype',1,'forcinglength',md.mesh.numberofvertices+1);
 		end % }}}
